#!/usr/bin/perl
# 2007 Nicholas Polys     npolys@vt.edu
# Free to use; No warranties
# Attribution appreciated

use strict;



use Data::Dumper;

my  @Temp = [];
my $name;
my @data =  [],[];
my $items= 0;
my $steps = 0;


if (!@ARGV){ $name = "anispace_v1.txt";
}else {      $name = $ARGV[0];

}


# get your file and build an array
open(INPUTF,$name) or die "can't open ".$name." .out data file!!!\n ";

while (<INPUTF>) {
    @Temp = split /\s+/ ;
    my $t;


    $steps = @Temp;

    $data[$items][0] = $Temp[0];

     for ($t = 1; $t <= $steps; $t++){

	$data[$items][$t] = $Temp[$t];      #

      }

     $items++;
}

 my $total_data = $steps;

$steps = ($steps - 1)/ 3;

close(INPUTF);



# prep your vrml text

my $vrml1 = "#VRML V2.0 utf8 \n";
my $vrml2 = "";
my $router1 = "";

my $iter;

$vrml1 .= " DEF WorldClock TimeSensor {cycleInterval 60} ";                   # setup world stuff
$vrml1 .= " DEF PS ProximitySensor {size 1000 1000 1000} ";
$vrml1 .= "  Transform { scale 5 5 5 children [ ";

for ($iter = 0; $iter < ($items -1); $iter++){                                     # make objects, interpolators, and tracline
 $vrml1 .= "Transform { translation 0 ".($iter * 2)." 0 children [";
 $vrml1 .= " DEF ".$data[$iter][0]." Transform { children Shape {geometry Box {size .2 .2 .2}} }";

### LINESET

 $vrml1 .= " DEF ".$data[$iter][0]."_L Transform { translation 0 0 0 children Shape { appearance Appearance {material Material {emissiveColor 1 1 1}} geometry IndexedLineSet { coord DEF ".$data[$iter][0]."_C Coordinate { point [";

 my $ind = "";
 my $c = 0;

 for (my $i=1; $i < $total_data; $i = $i +3){

      $vrml2 .= " ".$data[$iter][$i]." ".$data[$iter][$i+1]." ".$data[$iter][$i+2]." , \n";
      $ind .= " ".$c." " ;
      $c++;
 }

 $ind .= " -1 ";
 $vrml1 .= $vrml2."]} coordIndex [".$ind;

 $vrml1 .= "] } } } \n";


### INTERPOLATOR

 $vrml1 .= " DEF ".$data[$iter][0]."_I PositionInterpolator  {  keyValue ["; #.$vrml2;         ###### NOTE: REDUNDANT coords bloat me!
 $vrml1 .= "] key [";

 my $inte = 1.0 / $steps;

	for (my $i=0; $i <=1; $i = $i + $inte){
         $vrml1 .= " ".$i ;
	}

 $vrml1 .= "]       } \n";

 $vrml1 .= " Script { mustEvaluate TRUE directOutput TRUE field SFNode interp USE ".$data[$iter][0]."_I  field SFNode coord USE ".$data[$iter][0]."_C " ;
 $vrml1 .= " url \"javascript:  \n ";
 $vrml1 .= "  function initialize(){ interp.keyValue = coord.point; } \" ";
 $vrml1 .= "	}\n";

### ROUTES for events

   $router1 .= "ROUTE WorldClock.fraction_changed TO ".$data[$iter][0]."_I.set_fraction \n";
   $router1 .= "ROUTE ".$data[$iter][0]."_I.value_changed TO ".$data[$iter][0].".translation \n";

    $vrml1 .= "    ]}";  # close this plot's Transform
}
 $vrml1 .= "    ]}";


 $router1 .= "ROUTE PS.enterTime TO WorldClock.startTime";
 $vrml1 .= $router1;


 # write it to   the vrml file

open (OUTP,">anitestoutput.wrl") or die "can't open write file!!!\n ";

print OUTP $vrml1;

close (OUTP);

